###defaults

function map:collectible
function map:head
function map:slime
function map:hay
function map:fly_arrow


###levels
execute if score 7 Stage matches 1..99 run function map:lvls/7
execute as @a[x=-7,y=118,z=-106,distance=..2.5] unless score 7 Stage matches 1.. run scoreboard players set 7 Stage 1

function map:lvls/8
function map:lvls/9
function map:lvls/12
function map:lvls/17
function map:lvls/19
function map:lvls/20
function map:lvls/25
function map:lvls/26
function map:lvls/28
function map:lvls/29
function map:lvls/36

###level3
execute as @a[scores={Stage=3},gamemode=adventure,x=-2,y=113,z=-162,dx=10,dy=4,dz=19] at @s if block ~ ~ ~ light[level=1] run kill @s

###level7
execute as @a[scores={Stage=6},gamemode=adventure,x=-19,y=110,z=-89,distance=..3] at @s if block ~ ~ ~ light[level=2] run kill @s

###level7
execute as @a[scores={Stage=7},gamemode=adventure,x=-23,y=108,z=-101,dx=8,dy=4,dz=12] at @s if block ~ ~ ~ light[level=1] run kill @s

###level13
effect clear @a[gamemode=adventure,x=-4,y=122,z=-80,dx=1,dy=1,dz=1] speed
effect give @a[gamemode=adventure,x=-4,y=122,z=-82,dx=1,dy=1,dz=1] speed 999999 4 true
effect clear @a[gamemode=adventure,x=-5,y=133,z=-114,dx=2,dy=2,dz=2] speed

###level25
execute as @a[scores={Stage=25},gamemode=adventure,x=0,y=116,z=-171,dx=14,dy=5,dz=31] at @s if block ~ ~ ~ light[level=2] run kill @s

###level26
execute as @a[scores={Stage=26},gamemode=adventure,x=1,y=106,z=-140,dx=15,dy=4,dz=29] at @s if block ~ ~ ~ light[level=1] run kill @s

###level29_and_30
execute as @a[scores={Stage=29..30},gamemode=adventure,x=-41,y=150,z=-80,dx=45,dy=4,dz=16] at @s if block ~ ~ ~ light[level=1] run kill @s




###anti_cheat
execute as @a[gamemode=!adventure,tag=!build] at @s run tellraw @s ["",{"text":"Are You Sure You Want To Change Gamemodes?","color":"#FFEE00"},{"text":" "},{"text":"[Yes]","color":"#00FF03","clickEvent":{"action":"run_command","value":"/tag @s add building"},"hoverEvent":{"action":"show_text","contents":"click"}},{"text":" "},{"text":"[No]","color":"#FF0C0F","clickEvent":{"action":"run_command","value":"/tellraw @s {\"text\":\"Good Choice!\",\"color\":\"aqua\"}"},"hoverEvent":{"action":"show_text","contents":"click"}}]
tellraw @a[tag=building] {"text":"You Can Now Change Your Gamemode!","color":"aqua"}
tag @a[tag=building] add build
tag @a[tag=build] remove building
gamemode adventure @a[tag=!build]
execute as @a[gamemode=adventure] at @s if block ~ ~ ~ light[level=0] run kill @s


###lava
execute as @a[gamemode=adventure] at @s unless entity @s[nbt={ActiveEffects:[{Id:20b}]}] if block ~ ~0.2 ~ lava run effect give @s minecraft:wither 1 1 true
execute as @a[gamemode=adventure] at @s store result score @s inlava run data get entity @s Fire
execute as @a[gamemode=adventure] at @s if score @s inlava matches -19..299 run effect give @s minecraft:fire_resistance 1 1 true

###saturation
execute as @a[gamemode=adventure] unless entity @s[nbt={ActiveEffects:[{Id:20b}]}] run effect give @s minecraft:saturation 3 1 true

###instruction_armor_stands
execute as @e[type=armor_stand,tag=instruction] at @s if entity @p[distance=8..] unless entity @p[distance=..8] run data merge entity @s {CustomNameVisible:0b}
execute as @e[type=armor_stand,tag=instruction] at @s if entity @p[distance=..8] run data merge entity @s {CustomNameVisible:1b}

execute as @e[type=armor_stand,tag=looker] at @s run tp @s ~ ~ ~ facing entity @p
execute as @e[type=armor_stand,tag=spinner] at @s run tp @s ~ ~ ~ ~5 ~

###restart
execute as @a[scores={restarter=1},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:3}}}] run tellraw @s {"text":"Click Again To Confirm!","color":"#22FF00","bold":false}
execute as @a[scores={restarter=1},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:3}}}] run scoreboard players set @s restarter 2
execute as @a[scores={restarter=3..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:3}}}] run function map:restart
execute as @a[scores={restarter=3..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:3}}}] run scoreboard players reset @s restarter
execute as @a[scores={restarter=1..}] unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:3}}}] run scoreboard players reset @s restarter
execute as @a[scores={restarter=2}] run scoreboard players add @s restarttime 1
execute as @a[scores={restarttime=50}] run scoreboard players reset @s restarter
execute as @a[scores={restarttime=50}] run scoreboard players reset @s restarttime

execute as @e[type=item,nbt={Item:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:3}}}] at @s run item replace entity @p container.8 with carrot_on_a_stick{display:{Name:'{"text":"Restarter [Right Click]","color":"#FF8500","bold":true}',Lore:['{"text":"Right Click To Restart Your Run!","color":"light_purple","italic":true}']},Unbreakable:1b,CustomModelData:3} 1
execute as @e[type=item,nbt={Item:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:3}}}] at @s run kill @s

scoreboard players enable @a restart
execute as @a[scores={restart=1..}] at @s run function map:restart
execute as @a[scores={restart=1..}] at @s run scoreboard players reset @s restart

###map

###start
effect give @a[x=96,y=100,z=-94,dx=13,dy=12,dz=26] minecraft:levitation 4 3 true
effect clear @a[x=96,y=121,z=-94,dx=13,dy=2,dz=26] minecraft:levitation
effect give @a[x=96,y=109,z=-108,dx=13,dy=6,dz=12] minecraft:levitation 1 2 true
team join player @a[team=!player]
spawnpoint @a[x=105,y=116,z=-81,distance=..10] 105 118 -81 90

execute as @a[x=98,y=117,z=-102,distance=..2] at @s if block ~ ~-0.2 ~ minecraft:netherite_block run function map:restart

###settings
execute as @e[type=glow_item_frame,tag=settings,tag=time] if entity @s[nbt={Item:{tag:{CustomModelData:84}}}] unless entity @s[nbt={ItemRotation:0b}] run data merge entity @s {ItemRotation:0b,Item:{tag:{CustomModelData:85}}}
execute as @e[type=glow_item_frame,tag=settings,tag=time] if entity @s[nbt={Item:{tag:{CustomModelData:85}}}] unless entity @s[nbt={ItemRotation:0b}] run data merge entity @s {ItemRotation:0b,Item:{tag:{CustomModelData:86}}}
execute as @e[type=glow_item_frame,tag=settings,tag=time] if entity @s[nbt={Item:{tag:{CustomModelData:86}}}] unless entity @s[nbt={ItemRotation:0b}] run data merge entity @s {ItemRotation:0b,Item:{tag:{CustomModelData:84}}}
execute if entity @e[type=glow_item_frame,tag=settings,tag=time,nbt={Item:{tag:{CustomModelData:84}}}] run time set noon
execute if entity @e[type=glow_item_frame,tag=settings,tag=time,nbt={Item:{tag:{CustomModelData:84}}}] run gamerule doDaylightCycle false
execute if entity @e[type=glow_item_frame,tag=settings,tag=time,nbt={Item:{tag:{CustomModelData:85}}}] run time set midnight
execute if entity @e[type=glow_item_frame,tag=settings,tag=time,nbt={Item:{tag:{CustomModelData:85}}}] run gamerule doDaylightCycle false
execute if entity @e[type=glow_item_frame,tag=settings,tag=time,nbt={Item:{tag:{CustomModelData:86}}}] run gamerule doDaylightCycle true


execute as @e[type=glow_item_frame,tag=settings,tag=fire] if entity @s[nbt={Item:{tag:{CustomModelData:87}}}] unless entity @s[nbt={ItemRotation:0b}] run data merge entity @s {ItemRotation:0b,Item:{tag:{CustomModelData:88}}}
execute as @e[type=glow_item_frame,tag=settings,tag=fire] if entity @s[nbt={Item:{tag:{CustomModelData:88}}}] unless entity @s[nbt={ItemRotation:0b}] run data merge entity @s {ItemRotation:0b,Item:{tag:{CustomModelData:87}}}

execute if entity @e[type=glow_item_frame,tag=settings,tag=fire,nbt={Item:{tag:{CustomModelData:87}}}] run team modify player friendlyFire true
execute if entity @e[type=glow_item_frame,tag=settings,tag=fire,nbt={Item:{tag:{CustomModelData:88}}}] run team modify player friendlyFire false

execute as @e[type=glow_item_frame,tag=settings,tag=level] if entity @s[nbt={Item:{tag:{CustomModelData:89}}}] unless entity @s[nbt={ItemRotation:0b}] run data merge entity @s {ItemRotation:0b,Item:{tag:{CustomModelData:90}}}
execute as @e[type=glow_item_frame,tag=settings,tag=level] if entity @s[nbt={Item:{tag:{CustomModelData:90}}}] unless entity @s[nbt={ItemRotation:0b}] run data merge entity @s {ItemRotation:0b,Item:{tag:{CustomModelData:91}}}
execute as @e[type=glow_item_frame,tag=settings,tag=level] if entity @s[nbt={Item:{tag:{CustomModelData:91}}}] unless entity @s[nbt={ItemRotation:0b}] run data merge entity @s {ItemRotation:0b,Item:{tag:{CustomModelData:89}}}

execute if entity @e[type=glow_item_frame,tag=settings,tag=level,nbt={Item:{tag:{CustomModelData:89}}}] run scoreboard objectives setdisplay list Stage
execute if entity @e[type=glow_item_frame,tag=settings,tag=level,nbt={Item:{tag:{CustomModelData:90}}}] run scoreboard objectives setdisplay sidebar Stage
execute if entity @e[type=glow_item_frame,tag=settings,tag=level,nbt={Item:{tag:{CustomModelData:90}}}] run scoreboard objectives setdisplay list
execute if entity @e[type=glow_item_frame,tag=settings,tag=level,nbt={Item:{tag:{CustomModelData:91}}}] run scoreboard objectives setdisplay sidebar

###seamless_teleport
execute as @a[x=-12,y=86,z=-151,dx=2,dy=3,dz=5] at @s run tp @s ~-3 ~ ~50 ~ ~
execute as @a[x=-15,y=70,z=-63,dx=10,dy=4,dz=6] at @s run tp @s ~-13 ~19 ~61 ~ ~
execute as @a[x=-8,y=150,z=-220,distance=..3] at @s if block ~ ~ ~ light[level=2] run tp @s ~-17 ~31 ~73 ~ ~

###half_heart
tag @a[x=1,y=115,z=-142,dx=2,dy=1,dz=2,gamemode=adventure] add half_heart
tag @a[x=-6,y=87,z=-123,dx=4,dy=2,dz=4,gamemode=adventure] remove half_heart
tag @a[x=4,y=119.5,z=-138,distance=..2,gamemode=adventure] remove half_heart
tag @a[x=1,y=135,z=-176,distance=..4,gamemode=adventure] remove half_heart

tag @a[x=-20,y=136,z=18,dx=5,dy=2,dz=1,gamemode=adventure] add half_heart
tag @a[x=-23,y=138,z=25,distance=..3,gamemode=adventure] remove half_heart
execute as @a[x=-14,y=70,z=9,distance=..9,gamemode=adventure] at @s if block ~ ~ ~ water run tag @s remove half_heart

tag @a[x=-16,y=166,z=-185,distance=..3,gamemode=adventure] add half_heart
tag @a[x=-8,y=148,z=-207,distance=..4,gamemode=adventure] remove half_heart

###teleportaion
particle minecraft:portal -16 103 -103 0.1 0.2 0.1 0.2 1 normal
particle minecraft:portal -2 115.5 -83 0.1 0.2 0.1 0.2 1 normal
execute as @a[x=-16,y=104,z=-103,distance=..2] at @s if block ~ ~0.4 ~ dark_oak_slab if block ~ ~-4 ~ spruce_log run particle minecraft:dust 0.65 0 0.7 1 ~ ~1 ~ 0.2 0.4 0.2 0.1 300 normal
execute as @a[x=-16,y=104,z=-103,distance=..2] at @s if block ~ ~0.4 ~ dark_oak_slab if block ~ ~-4 ~ spruce_log run tp @s -2 116.5 -83 135 0

particle minecraft:portal -5 107.5 0 0.1 0.2 0.1 0.2 1 normal
particle minecraft:portal -18 113.5 3 0.1 0.2 0.1 0.2 1 normal
execute as @a[x=-5,y=108,z=0,distance=..2] at @s if block ~ ~-2.4 ~ diorite if block ~ ~-0.1 ~ grass_block run particle minecraft:dust 0.65 0 0.7 1 ~ ~1 ~ 0.2 0.4 0.2 0.1 300 normal
execute as @a[x=-5,y=108,z=0,distance=..2] at @s if block ~ ~-2.4 ~ diorite if block ~ ~-0.1 ~ grass_block run tp @s -18 115 3 165 0

particle minecraft:portal -23 118.5 -19 0.1 0.2 0.1 0.2 1 normal
execute as @a[x=-23,y=119,z=-19,distance=..2] at @s if block ~ ~-2 ~ birch_planks if block ~ ~-0.1 ~ andesite run particle minecraft:dust 0.65 0 0.7 1 ~ ~1 ~ 0.2 0.4 0.2 0.1 300 normal
execute as @a[x=-23,y=119,z=-19,distance=..2] at @s if block ~ ~-2 ~ birch_planks if block ~ ~-0.1 ~ andesite run tp @s -24 132 -186 -160 0

particle minecraft:portal 1 117.5 -108 0.1 0.2 0.1 0.2 1 normal
execute as @a[x=1,y=118,z=-108,distance=..2] at @s if block ~ ~-1.5 ~ diorite run particle minecraft:dust 0.65 0 0.7 1 ~ ~1 ~ 0.2 0.4 0.2 0.1 300 normal
execute as @a[x=1,y=118,z=-108,distance=..2] at @s if block ~ ~-1.5 ~ diorite run tp @s -19 148.5 -34 180 0

particle minecraft:portal 7 163.5 39 0.1 0.2 0.1 0.2 1 normal
execute as @a[x=7,y=164,z=39,distance=..2] at @s if block ~ ~-1.5 ~ birch_planks run particle minecraft:dust 0.65 0 0.7 1 ~ ~1 ~ 0.2 0.4 0.2 0.1 300 normal
execute as @a[x=7,y=164,z=39,distance=..2] at @s if block ~ ~-1.5 ~ birch_planks run tp @s -19 151.5 -135 -135 0

###levitation
particle minecraft:end_rod -24 105.5 -64 0.1 0.3 0.1 0.02 5 normal
execute as @a[x=-24,y=106,z=-64,distance=..1] at @s if block ~ ~-0.1 ~ barrier run effect give @s levitation 2 3 true

particle minecraft:end_rod 1 89.5 -53 0.1 0.3 0.1 0.02 5 normal
execute as @a[x=1,y=90,z=-53,distance=..1] at @s if block ~ ~-0.1 ~ barrier run effect give @s levitation 2 7 true

particle minecraft:end_rod -35 137.5 -107 0.1 0.3 0.1 0.02 5 normal
execute as @a[x=-35,y=138,z=-107,distance=..1] at @s if block ~ ~-0.1 ~ barrier run effect give @s levitation 2 3 true

particle minecraft:end_rod -9.99 90.5 -4.99 0.4 0.3 0.4 0.02 8 normal
execute as @a[x=-10,y=92,z=-5,distance=..3] at @s if block ~ ~-0.1 ~ barrier run effect give @s levitation 3 3 true

particle minecraft:end_rod -3 155.5 -164 0.1 0.3 0.1 0.02 5 normal
execute as @a[x=-3,y=156,z=-164,distance=..2] at @s if block ~ ~-0.1 ~ barrier run effect give @s levitation 2 5 true

particle minecraft:end_rod -7 185.5 -108 0.1 0.3 0.1 0.02 5 normal
execute as @a[x=-7,y=186,z=-108,distance=..2] at @s if block ~ ~-0.1 ~ barrier run effect give @s levitation 3 7 true

particle minecraft:end_rod -17 210.5 -108 0.1 0.3 0.1 0.02 5 normal
execute as @a[x=-17,y=211,z=-108,distance=..2] at @s if block ~ ~-0.1 ~ barrier run effect give @s levitation 2 2 true

###jump_boost
particle minecraft:dust 0.4 1 0.2 1 -37 98 -48 0.15 0.25 0.15 0.1 1 normal
execute as @a[x=-37,y=98,z=-48,distance=..0.8] at @s run effect give @s jump_boost 5 3 true
execute as @a[x=-33,y=116,z=-40,distance=..4] at @s run effect clear @s jump_boost

###end
execute as @e[tag=end,tag=spinner] at @s run particle dust 0.349 1.000 0.718 1 ^0.8 ^ ^ 0 0 0 0.2 2 normal
execute as @e[tag=end,tag=spinner] at @s run particle dust 0.349 1.000 0.718 1 ^-0.8 ^ ^ 0 0 0 0.2 2 normal
execute as @e[tag=end,tag=spinner] at @s run particle dust 0.690 1.000 0.886 1 ^0.8 ^-0.2 ^-0.4 0 0 0 0.2 1 normal
execute as @e[tag=end,tag=spinner] at @s run particle dust 0.690 1.000 0.886 1 ^-0.8 ^-0.2 ^0.4 0 0 0 0.2 1 normal
execute as @e[tag=end,tag=spinner] at @s run particle dust 1.000 1.000 1.000 1 ^0.8 ^-0.4 ^-0.8 0 0 0 0.2 0 normal
execute as @e[tag=end,tag=spinner] at @s run particle dust 1.000 1.000 1.000 1 ^-0.8 ^-0.4 ^0.8 0 0 0 0.2 0 normal
execute as @e[tag=end,tag=spinner] at @s run tp @s ~ ~0.05 ~
execute as @e[x=-11,y=221,z=-108,distance=..1,type=minecraft:armor_stand,tag=spinner,tag=end] at @s run tp @s ~ ~-3 ~

execute as @a[x=-11,y=218,z=-108,distance=..1,tag=!finished] at @s if block ~ ~-0.1 ~ minecraft:diamond_block run tag @s add finish
execute as @a[x=-11,y=218,z=-108,distance=..1,tag=finish] at @s run spawnpoint @s -11 219 -108 -90
execute as @a[x=-11,y=218,z=-108,distance=..1,tag=finish] at @s if score @s time_hour matches 1.. run tellraw @a ["",{"text":"Congratulations! ","color":"#ff9d00"},{"selector":"@s","color":"#FFC600"},{"text":" Finished ","color":"#FFC600"},{"text":"Hexa Parkour ","color":"#ff7b00"},{"text":"In ","color":"#FFC600"},{"score":{"name":"@s","objective":"time_hour"},"color":"#FFC600"},{"text":" hours,","color":"#FFC600"},{"score":{"name":"@s","objective":"time_min"},"color":"#FFC600"},{"text":" minutes, ","color":"#FFC600"},{"score":{"name":"@s","objective":"time_sec"},"color":"#FFC600"},{"text":" seconds!","color":"#FFC600"}]
execute as @a[x=-11,y=218,z=-108,distance=..1,tag=finish] at @s unless score @s time_hour matches 1.. run tellraw @a ["",{"text":"Congratulations! ","color":"#ff9d00"},{"selector":"@s","color":"#FFC600"},{"text":" Finished ","color":"#FFC600"},{"text":"Hexa Parkour ","color":"#ff7b00"},{"text":"In ","color":"#FFC600"},{"score":{"name":"@s","objective":"time_min"},"color":"#FFC600"},{"text":" minutes, ","color":"#FFC600"},{"score":{"name":"@s","objective":"time_sec"},"color":"#FFC600"},{"text":" seconds!","color":"#FFC600"}]
execute as @a[x=-11,y=218,z=-108,distance=..1,tag=!finished] at @s run summon firework_rocket ~ ~3 ~ {Life:0,LifeTime:15,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Flicker:1b,Trail:1b,Colors:[I;16711680,11771135,3604439,13303608,15662848,5444863,16723676],FadeColors:[I;16711680,9175040,4849664,0]}]}}}}

execute as @a[tag=finish] at @s run tag @s remove time_run
execute as @a[tag=finish] at @s run tag @s add finished
execute as @a[tag=finished] at @s run tag @s remove finish